Index: /GTP/trunk/Lib/Vis/Preprocessing/scripts/TestPreprocessor.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/scripts/TestPreprocessor.vcproj	(revision 1002)
+++ /GTP/trunk/Lib/Vis/Preprocessing/scripts/TestPreprocessor.vcproj	(revision 1011)
@@ -84,5 +84,5 @@
 				OutputFile="$(OutDir)/Preprocessor.exe"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="..\support\xercesc\lib\;..\support\zlib\lib\;..\support\devil\lib;&quot;$(QTDIR)\lib&quot;;..\include;..\src\GL;&quot;$(CG_LIB_PATH)&quot;;&quot;$(GTPDIR)\NonGTP\Xerces&quot;;&quot;$(GTPDIR)\NonGTP\Xerces\xercesc\lib&quot;;&quot;$(GTPDIR)\NonGTP\zlib\lib&quot;;&quot;$(GTPDIR)\NonGTP\Devil\lib&quot;;..\lib\release"
+				AdditionalLibraryDirectories="..\support\xercesc\lib\;..\support\zlib\lib\;..\support\devil\lib;&quot;$(QTDIR)\lib&quot;;..\include;..\src\GL;&quot;$(CG_LIB_PATH)&quot;;&quot;$(GTPDIR)\NonGTP\Xerces&quot;;&quot;$(GTPDIR)\NonGTP\Xerces\xercesc\lib&quot;;&quot;$(GTPDIR)\NonGTP\zlib\lib&quot;;&quot;$(GTPDIR)\NonGTP\Devil\lib&quot;;..\lib\release;..\..\Preprocessing\lib\release"
 				GenerateDebugInformation="FALSE"
 				SubSystem="1"
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/VspKdTree.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/VspKdTree.cpp	(revision 1006)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/VspKdTree.cpp	(revision 1011)
@@ -147,4 +147,5 @@
 }
 
+
 void VspKdInterior::Print(ostream &s) const
 {
@@ -165,4 +166,5 @@
 }
 
+
 int VspKdInterior::ComputeRayIntersection(const RayInfo &rayData, float &t)
 {
@@ -170,8 +172,10 @@
 }
 
+
 VspKdNode *VspKdInterior::GetBack() const
 {
 	return mBack;
 }
+
 
 VspKdNode *VspKdInterior::GetFront() const
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 1006)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 1011)
@@ -68,6 +68,5 @@
 	bool randomize = false;
 	Environment::GetSingleton()->GetBoolValue("VspBspTree.Construction.randomize", randomize);
-	if (randomize)
-		Randomize(); // initialise random generator for heuristics
+	if (randomize) Randomize(); // initialise random generator for heuristics
 
 	//-- termination criteria for autopartition
@@ -87,6 +86,4 @@
 	Environment::GetSingleton()->GetFloatValue("VspBspTree.Termination.minGlobalCostRatio", mTermMinGlobalCostRatio);
 	Environment::GetSingleton()->GetIntValue("VspBspTree.Termination.globalCostMissTolerance", mTermGlobalCostMissTolerance);
-
-	// HACK//mTermMinPolygons = 25;
 
 	//-- factors for bsp tree split plane heuristics
@@ -2736,4 +2733,6 @@
 				const int side = plane.Side(bRay.ExtrapOrigin());
 
+				++ splits;
+
 				if (side <= 0)
 				{
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1010)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1011)
@@ -124,4 +124,5 @@
 {}
 
+
 VspInterior::~VspInterior() 
 { 
@@ -130,4 +131,5 @@
 }
 
+
 bool VspInterior::IsLeaf() const
 { 
@@ -135,4 +137,5 @@
 }
 
+
 VspNode *VspInterior::GetBack() 
 {
@@ -140,4 +143,5 @@
 }
 
+
 VspNode *VspInterior::GetFront() 
 {
@@ -145,8 +149,10 @@
 }
 
+
 AxisAlignedPlane VspInterior::GetPlane() const
 {
 	return mPlane;
 }
+
 
 void VspInterior::ReplaceChildLink(VspNode *oldChild, VspNode *newChild) 
@@ -157,4 +163,5 @@
 		mFront = newChild;
 }
+
 
 void VspInterior::SetupChildLinks(VspNode *b, VspNode *f) 
@@ -527,8 +534,7 @@
 {
 	return
-		(mOutOfMemory 
-		|| (mVspStats.Leaves() >= mMaxViewCells) 
-		|| (mGlobalCostMisses >= mTermGlobalCostMissTolerance)
-		 );
+		(mOutOfMemory || 
+		(mVspStats.Leaves() >= mMaxViewCells) || 
+		(mGlobalCostMisses >= mTermGlobalCostMissTolerance));
 }
 
@@ -680,27 +686,18 @@
 	backData.mRays = new RayInfoContainer();
 	
-
 	//-- subdivide rays
-#if TODO	
 	SplitRays(splitPlane,
 			  *tData.mRays,
 			  *frontData.mRays,
 			  *backData.mRays);
-#endif
-
-	// compute pvs
+
+	//-- compute pvs
 	frontData.mPvs = ComputePvsSize(*frontData.mRays);
 	backData.mPvs = ComputePvsSize(*backData.mRays);
 
 	// split front and back node geometry and compute area
-	
-	// if geometry was not already computed
-	// TODO
-
-#if TODO
 	tData.mBoundingBox.Split(splitPlane.mAxis, splitPlane.mPosition, 
 							 frontData.mBoundingBox, backData.mBoundingBox);
 
-#endif
 
 	frontData.mProbability = frontData.mBoundingBox.GetVolume();
@@ -1039,9 +1036,4 @@
 	int bestAxis = -1;
 
-#if 0
-	// maximum cost ratio for axis to be valid:
-	// if exceeded, spatial mid split is used instead
-	const maxCostRatioForHeur = 0.99f;
-#endif
 
 	// if we use some kind of specialised fixed axis
@@ -1146,8 +1138,11 @@
 	}
 
-#if TODO
-	pFront = geomFront.GetVolume();
+	AxisAlignedBox3 frontBox;
+	AxisAlignedBox3 backBox;
+
+	data.mBoundingBox.Split(candidatePlane.mAxis, candidatePlane.mPosition, frontBox, backBox);
+
+	pFront = frontBox.GetVolume();
 	pBack = pOverall - pFront;
-#endif
 		
 
@@ -1399,4 +1394,5 @@
 	Intersectable::NewMail();
 	ViewCell::NewMail();
+
 	Vector3 entp = ray.Extrap(mint);
 	Vector3 extp = ray.Extrap(maxt);
@@ -1651,59 +1647,4 @@
 
 
-int VspOspTree::SplitRays(const Plane3 &plane,
-						  RayInfoContainer &rays,
-						  RayInfoContainer &frontRays,
-						  RayInfoContainer &backRays) const
-{
-	int splits = 0;
-
-	RayInfoContainer::const_iterator it, it_end = rays.end();
-
-	for (it = rays.begin(); it != it_end; ++ it)
-	{
-		RayInfo bRay = *it;
-		
-		VssRay *ray = bRay.mRay;
-		float t;
-
-		// get classification and receive new t
-		const int cf = bRay.ComputeRayIntersection(plane, t);
-
-		switch (cf)
-		{
-		case -1:
-			backRays.push_back(bRay);
-			break;
-		case 1:
-			frontRays.push_back(bRay);
-			break;
-		case 0:
-			{
-				//-- split ray
-				//-- test if start point behind or in front of plane
-				const int side = plane.Side(bRay.ExtrapOrigin());
-
-				if (side <= 0)
-				{
-					backRays.push_back(RayInfo(ray, bRay.GetMinT(), t));
-					frontRays.push_back(RayInfo(ray, t, bRay.GetMaxT()));
-				}
-				else
-				{
-					frontRays.push_back(RayInfo(ray, bRay.GetMinT(), t));
-					backRays.push_back(RayInfo(ray, t, bRay.GetMaxT()));
-				}
-			}
-			break;
-		default:
-			Debug << "Should not come here" << endl;
-			break;
-		}
-	}
-
-	return splits;
-}
-
-
 int VspOspTree::FindNeighbors(VspNode *n, vector<VspLeaf *> &neighbors,
 							  const bool onlyUnmailed) const
@@ -1849,5 +1790,5 @@
 	int hits = 0;
 #if TODO
-	stack<BspRayTraversalData> tStack;
+	stack<VspRayTraversalData> tStack;
 
 	float mint = 0.0f, maxt = 1.0f;
@@ -2195,3 +2136,53 @@
 }
 
-}
+
+int VspOspTree::SplitRays(const AxisAlignedPlane &plane,
+						  RayInfoContainer &rays,
+						  RayInfoContainer &frontRays,
+						  RayInfoContainer &backRays) const
+{
+	int splits = 0;
+
+	RayInfoContainer::const_iterator rit, rit_end = rays.end();
+
+	for (rit = rays.begin(); rit != rit_end; ++ rit)
+	{
+		RayInfo bRay = *rit;
+		
+		VssRay *ray = bRay.mRay;
+		float t;
+
+		// get classification and receive new t
+		//-- test if start point behind or in front of plane
+		const int side = plane.ComputeRayIntersection(bRay, t);
+
+		if (side == 0)
+		{
+			++ splits;
+
+			if (ray->HasPosDir(plane.mAxis))
+			{
+				backRays.push_back(RayInfo(ray, bRay.GetMinT(), t));
+				frontRays.push_back(RayInfo(ray, t, bRay.GetMaxT()));
+			}
+			else
+			{
+				frontRays.push_back(RayInfo(ray, bRay.GetMinT(), t));
+				backRays.push_back(RayInfo(ray, t, bRay.GetMaxT()));
+			}
+		}
+		else if (side == 1)
+		{
+			frontRays.push_back(bRay);
+		}
+		else
+		{
+			backRays.push_back(bRay);
+		}
+
+	}
+
+	return splits;
+}
+
+}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.h	(revision 1010)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.h	(revision 1011)
@@ -35,4 +35,10 @@
 {
 public:
+
+	int ComputeRayIntersection(const RayInfo &rayData, float &t) const
+	{
+		return rayData.ComputeRayIntersection(mAxis, mPosition, t);
+	}
+
 	int mAxis;
 	float mPosition;
@@ -742,5 +748,5 @@
 		@returns the number of splits
 	*/
-	int SplitRays(const Plane3 &plane,
+	int SplitRays(const AxisAlignedPlane &plane,
 				  RayInfoContainer &rays, 
 			      RayInfoContainer &frontRays, 
Index: /GTP/trunk/Lib/Vis/shared/scripts/GtpVisibility.sln
===================================================================
--- /GTP/trunk/Lib/Vis/shared/scripts/GtpVisibility.sln	(revision 1004)
+++ /GTP/trunk/Lib/Vis/shared/scripts/GtpVisibility.sln	(revision 1011)
@@ -1,34 +1,34 @@
 Microsoft Visual Studio Solution File, Format Version 8.00
-Project("{EAF909A5-FA59-4C3D-9431-0FCC20D5BCF9}") = "Preprocessor", "..\..\Preprocessing\scripts\Preprocessor.icproj", "{1C63E944-5E2E-447C-AE75-F1BF14641C98}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "Preprocessor", "..\..\Preprocessing\scripts\Preprocessor.vcproj", "{EABCE292-D598-4600-A1C9-2591E7D62FDA}"
 	ProjectSection(ProjectDependencies) = postProject
 	EndProjectSection
 EndProject
-Project("{EAF909A5-FA59-4C3D-9431-0FCC20D5BCF9}") = "GtpVisibility", "..\..\OnlineCullingCHC\scripts\GtpVisibility.icproj", "{C1910FAC-39EA-49F1-B93C-517E15D1C250}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "GtpVisibility", "..\..\OnlineCullingCHC\scripts\GtpVisibility.vcproj", "{101A7691-74F3-48B4-96A3-CF35578F5900}"
 	ProjectSection(ProjectDependencies) = postProject
-		{1C63E944-5E2E-447C-AE75-F1BF14641C98} = {1C63E944-5E2E-447C-AE75-F1BF14641C98}
+		{EABCE292-D598-4600-A1C9-2591E7D62FDA} = {EABCE292-D598-4600-A1C9-2591E7D62FDA}
 	EndProjectSection
 EndProject
-Project("{EAF909A5-FA59-4C3D-9431-0FCC20D5BCF9}") = "TestCullingTerrain", "..\..\..\..\App\Demos\Vis\HillyTerrain\OGRE\TestCullingTerrain.icproj", "{D26A9780-4457-473C-A391-BBEB7758E2D0}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "TestCullingTerrain", "..\..\..\..\App\Demos\Vis\HillyTerrain\OGRE\TestCullingTerrain.vcproj", "{248F19A6-2FE0-4F5D-8928-E0EA10609887}"
 	ProjectSection(ProjectDependencies) = postProject
-		{4FC8EE48-701E-474E-88CB-FFD17E8A778B} = {4FC8EE48-701E-474E-88CB-FFD17E8A778B}
-		{C1910FAC-39EA-49F1-B93C-517E15D1C250} = {C1910FAC-39EA-49F1-B93C-517E15D1C250}
-		{7499CFDA-3C7F-4660-B1D3-8A41EA2EBFA3} = {7499CFDA-3C7F-4660-B1D3-8A41EA2EBFA3}
+		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436} = {80DECC17-BDDD-4412-8CF8-F7C1C17A7436}
+		{101A7691-74F3-48B4-96A3-CF35578F5900} = {101A7691-74F3-48B4-96A3-CF35578F5900}
+		{7319E499-473D-4CE5-9983-725D6E68A55D} = {7319E499-473D-4CE5-9983-725D6E68A55D}
 	EndProjectSection
 EndProject
-Project("{EAF909A5-FA59-4C3D-9431-0FCC20D5BCF9}") = "Plugin_VisibilitySceneManager", "..\..\OnlineCullingCHC\OGRE\scripts\Plugin_VisibilitySceneManager.icproj", "{4FC8EE48-701E-474E-88CB-FFD17E8A778B}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "Plugin_VisibilitySceneManager", "..\..\OnlineCullingCHC\OGRE\scripts\Plugin_VisibilitySceneManager.vcproj", "{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}"
 	ProjectSection(ProjectDependencies) = postProject
-		{C1910FAC-39EA-49F1-B93C-517E15D1C250} = {C1910FAC-39EA-49F1-B93C-517E15D1C250}
+		{101A7691-74F3-48B4-96A3-CF35578F5900} = {101A7691-74F3-48B4-96A3-CF35578F5900}
 	EndProjectSection
 EndProject
-Project("{EAF909A5-FA59-4C3D-9431-0FCC20D5BCF9}") = "EvalStats", "..\EvalStats\EvalStats.icproj", "{A83C475F-BE2B-452B-B702-97C8F125D31D}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "EvalStats", "..\EvalStats\EvalStats.vcproj", "{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}"
 	ProjectSection(ProjectDependencies) = postProject
 	EndProjectSection
 EndProject
-Project("{EAF909A5-FA59-4C3D-9431-0FCC20D5BCF9}") = "TestPreprocessor", "..\..\Preprocessing\scripts\TestPreprocessor.icproj", "{6DB3C2CD-BBE6-463D-A9D3-92240C71ED22}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "TestPreprocessor", "..\..\Preprocessing\scripts\TestPreprocessor.vcproj", "{69BC58F0-C7EB-4B43-B782-B6F047EF0528}"
 	ProjectSection(ProjectDependencies) = postProject
-		{1C63E944-5E2E-447C-AE75-F1BF14641C98} = {1C63E944-5E2E-447C-AE75-F1BF14641C98}
+		{EABCE292-D598-4600-A1C9-2591E7D62FDA} = {EABCE292-D598-4600-A1C9-2591E7D62FDA}
 	EndProjectSection
 EndProject
-Project("{EAF909A5-FA59-4C3D-9431-0FCC20D5BCF9}") = "IVReader", "..\..\OnlineCullingCHC\IVReader\scripts\IVReader.icproj", "{7499CFDA-3C7F-4660-B1D3-8A41EA2EBFA3}"
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "IVReader", "..\..\OnlineCullingCHC\IVReader\scripts\IVReader.vcproj", "{7319E499-473D-4CE5-9983-725D6E68A55D}"
 	ProjectSection(ProjectDependencies) = postProject
 	EndProjectSection
@@ -40,60 +40,32 @@
 	EndGlobalSection
 	GlobalSection(ProjectConfiguration) = postSolution
-		{1C63E944-5E2E-447C-AE75-F1BF14641C98}.Debug.ActiveCfg = Debug|Win32
-		{1C63E944-5E2E-447C-AE75-F1BF14641C98}.Debug.Build.0 = Debug|Win32
-		{1C63E944-5E2E-447C-AE75-F1BF14641C98}.Release.ActiveCfg = Release|Win32
-		{1C63E944-5E2E-447C-AE75-F1BF14641C98}.Release.Build.0 = Release|Win32
-		{C1910FAC-39EA-49F1-B93C-517E15D1C250}.Debug.ActiveCfg = Debug|Win32
-		{C1910FAC-39EA-49F1-B93C-517E15D1C250}.Debug.Build.0 = Debug|Win32
-		{C1910FAC-39EA-49F1-B93C-517E15D1C250}.Release.ActiveCfg = Release|Win32
-		{C1910FAC-39EA-49F1-B93C-517E15D1C250}.Release.Build.0 = Release|Win32
-		{D26A9780-4457-473C-A391-BBEB7758E2D0}.Debug.ActiveCfg = Debug|Win32
-		{D26A9780-4457-473C-A391-BBEB7758E2D0}.Debug.Build.0 = Debug|Win32
-		{D26A9780-4457-473C-A391-BBEB7758E2D0}.Release.ActiveCfg = Release|Win32
-		{D26A9780-4457-473C-A391-BBEB7758E2D0}.Release.Build.0 = Release|Win32
-		{4FC8EE48-701E-474E-88CB-FFD17E8A778B}.Debug.ActiveCfg = Debug|Win32
-		{4FC8EE48-701E-474E-88CB-FFD17E8A778B}.Debug.Build.0 = Debug|Win32
-		{4FC8EE48-701E-474E-88CB-FFD17E8A778B}.Release.ActiveCfg = Release|Win32
-		{4FC8EE48-701E-474E-88CB-FFD17E8A778B}.Release.Build.0 = Release|Win32
-		{A83C475F-BE2B-452B-B702-97C8F125D31D}.Debug.ActiveCfg = Debug|Win32
-		{A83C475F-BE2B-452B-B702-97C8F125D31D}.Debug.Build.0 = Debug|Win32
-		{A83C475F-BE2B-452B-B702-97C8F125D31D}.Release.ActiveCfg = Release|Win32
-		{A83C475F-BE2B-452B-B702-97C8F125D31D}.Release.Build.0 = Release|Win32
-		{6DB3C2CD-BBE6-463D-A9D3-92240C71ED22}.Debug.ActiveCfg = Debug|Win32
-		{6DB3C2CD-BBE6-463D-A9D3-92240C71ED22}.Debug.Build.0 = Debug|Win32
-		{6DB3C2CD-BBE6-463D-A9D3-92240C71ED22}.Release.ActiveCfg = Release|Win32
-		{6DB3C2CD-BBE6-463D-A9D3-92240C71ED22}.Release.Build.0 = Release|Win32
-		{7499CFDA-3C7F-4660-B1D3-8A41EA2EBFA3}.Debug.ActiveCfg = Debug|Win32
-		{7499CFDA-3C7F-4660-B1D3-8A41EA2EBFA3}.Debug.Build.0 = Debug|Win32
-		{7499CFDA-3C7F-4660-B1D3-8A41EA2EBFA3}.Release.ActiveCfg = Release|Win32
-		{7499CFDA-3C7F-4660-B1D3-8A41EA2EBFA3}.Release.Build.0 = Release|Win32
+		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Debug.ActiveCfg = Debug|Win32
+		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Debug.Build.0 = Debug|Win32
+		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release.ActiveCfg = Release|Win32
 		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release.Build.0 = Release|Win32
-		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Release.ActiveCfg = Release|Win32
-		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Debug.Build.0 = Debug|Win32
-		{EABCE292-D598-4600-A1C9-2591E7D62FDA}.Debug.ActiveCfg = Debug|Win32
+		{101A7691-74F3-48B4-96A3-CF35578F5900}.Debug.ActiveCfg = Debug|Win32
+		{101A7691-74F3-48B4-96A3-CF35578F5900}.Debug.Build.0 = Debug|Win32
+		{101A7691-74F3-48B4-96A3-CF35578F5900}.Release.ActiveCfg = Release|Win32
 		{101A7691-74F3-48B4-96A3-CF35578F5900}.Release.Build.0 = Release|Win32
-		{101A7691-74F3-48B4-96A3-CF35578F5900}.Release.ActiveCfg = Release|Win32
-		{101A7691-74F3-48B4-96A3-CF35578F5900}.Debug.Build.0 = Debug|Win32
-		{101A7691-74F3-48B4-96A3-CF35578F5900}.Debug.ActiveCfg = Debug|Win32
+		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Debug.ActiveCfg = Debug|Win32
+		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Debug.Build.0 = Debug|Win32
+		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Release.ActiveCfg = Release|Win32
 		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Release.Build.0 = Release|Win32
-		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Release.ActiveCfg = Release|Win32
-		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Debug.Build.0 = Debug|Win32
-		{248F19A6-2FE0-4F5D-8928-E0EA10609887}.Debug.ActiveCfg = Debug|Win32
+		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.Debug.ActiveCfg = Debug|Win32
+		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.Debug.Build.0 = Debug|Win32
+		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.Release.ActiveCfg = Release|Win32
 		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.Release.Build.0 = Release|Win32
-		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.Release.ActiveCfg = Release|Win32
-		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.Debug.Build.0 = Debug|Win32
-		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}.Debug.ActiveCfg = Debug|Win32
+		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.Debug.ActiveCfg = Debug|Win32
+		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.Debug.Build.0 = Debug|Win32
+		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.Release.ActiveCfg = Release|Win32
 		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.Release.Build.0 = Release|Win32
-		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.Release.ActiveCfg = Release|Win32
-		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.Debug.Build.0 = Debug|Win32
-		{935D1BDD-41B0-49F1-A86C-EB49B94DDB20}.Debug.ActiveCfg = Debug|Win32
+		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Debug.ActiveCfg = Debug|Win32
+		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Debug.Build.0 = Debug|Win32
+		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release.ActiveCfg = Release|Win32
 		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release.Build.0 = Release|Win32
-		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Release.ActiveCfg = Release|Win32
-		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Debug.Build.0 = Debug|Win32
-		{69BC58F0-C7EB-4B43-B782-B6F047EF0528}.Debug.ActiveCfg = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Debug.ActiveCfg = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Debug.Build.0 = Debug|Win32
+		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release.ActiveCfg = Release|Win32
 		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release.Build.0 = Release|Win32
-		{7319E499-473D-4CE5-9983-725D6E68A55D}.Release.ActiveCfg = Release|Win32
-		{7319E499-473D-4CE5-9983-725D6E68A55D}.Debug.Build.0 = Debug|Win32
-		{7319E499-473D-4CE5-9983-725D6E68A55D}.Debug.ActiveCfg = Debug|Win32
 	EndGlobalSection
 	GlobalSection(ExtensibilityGlobals) = postSolution