Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsLibrary.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsLibrary.h	(revision 1009)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsLibrary.h	(revision 1014)
@@ -50,5 +50,11 @@
 
 	/// LodStripsLibrary interface class.
-	/** This module contains functions that handle the levels of detail of the input multiresolution objects made of polygonal meshes. For any given resolution and object, this module returns a set of triangle strips representing the object at that resolution, that is, at the level of detail requested. These models use triangle strips to reduce storage usage and to speed up realistic rendering.
+	/** This module contains functions that handle the levels of detail 
+	 * 	of the input multiresolution objects made of polygonal meshes.
+	 * 	For any given resolution and object, this module returns a set
+	 * 	of triangle strips representing the object at that resolution, 
+	 * 	that is, at the level of detail requested. These models use 
+	 * 	triangle strips to reduce storage usage and to speed up realistic 
+	 * 	rendering.
 	\n\n
 
@@ -58,5 +64,6 @@
 
 Outputs:\n
-	- The module returns a strip set that represents the level of detail requested.
+	- The module returns a strip set that represents the level of 
+		detail requested.
 	.
 
@@ -65,9 +72,10 @@
 	{
 		private:
+			
+			// The name of the object.
+			String	mName; 
 
-			String	mName; /// The name of the object.
-
-			///Structures with the data read from the file
-			///We won't work with these structures
+			//	Structures with the data read from the file
+			//	We won't work with these structures
 			SmallIntVector									mFileVertices;
 			std::vector	<LODRegisterType>		mFileChangesLOD;
@@ -75,13 +83,22 @@
 			LongVector											mData;
 
-			///Structures with the data to work with
-			SmallInt	mTotalStrips;		///Total strips of the multiresolution object.
-			SmallInt	mTotalVertices;	///Total vertices of the multiresolution object.
-			SmallInt	mMaxVerticesLOD;///Number of vertices of the max LOD.
-			SmallInt	mTotalChanges;	///Total changes of the multiresolution object.
-			SmallInt	mLods;					///Available Lods.
-			SmallInt	mMaxLod;				///Max level of detail.
-			SmallInt	mMinLod;				///Min level of detail.
-			SmallInt	mCurrentLod;		///Current Lod.
+			//	Structures with the data to work with
+
+			//	Total strips of the multiresolution object.
+			SmallInt	mTotalStrips;
+			
+			//	Total vertices of the multiresolution object.
+			SmallInt	mTotalVertices;
+			
+			//	Number of vertices of the max LOD.
+			SmallInt	mMaxVerticesLOD;
+			
+			//	Total changes of the multiresolution object.
+			SmallInt	mTotalChanges;
+			
+			SmallInt	mLods;				//	Available Lods.
+			SmallInt	mMaxLod;			//	Max level of detail.
+			SmallInt	mMinLod;			//	Min level of detail.
+			SmallInt	mCurrentLod;	//	Current Lod.
 
 			//	For the efficient version.
@@ -112,5 +129,7 @@
 			SmallIntVector	*mStrips;
 			
-			/// Constructor, receives as a parameter the name of the file including the multiresolution object.
+			/**	Constructor, receives as a parameter the name of the file
+			 * 	including the multiresolution object.
+			*/
 			LodStripsLibrary(std::string, Mesh *geomesh);
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoBase.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoBase.h	(revision 980)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoBase.h	(revision 1014)
@@ -14,5 +14,5 @@
 namespace Geometry {
 
-	//Basic types
+	//	Basic types.
 	typedef float 					Real;
 	typedef unsigned int		Index;
@@ -22,5 +22,5 @@
 	typedef std::string			String;
 
-	//Vertex Info
+	//	Vertex Info.
 	static const unsigned short VERTEX_EMPTY     = 0x00;
 	static const unsigned short VERTEX_POSITION  = 0x01;
@@ -29,5 +29,5 @@
 	static const unsigned short VERTEX_ALL = VERTEX_POSITION | VERTEX_NORMAL | VERTEX_TEXCOORDS;
 
-	//Mmesh primitives
+	//	Mesh primitives.
 	typedef enum 
 	{
@@ -36,5 +36,4 @@
 	} MeshType;
 
-		//OSCAR
 	struct VertexBoneAssignment
 	{
@@ -57,6 +56,4 @@
 	};
 	
-	//	2006-02-14
-	//	Gustavo Puche.
 	//	Needed to update the progress bar.
 	typedef float updateProgressBar(float);
@@ -78,2 +75,3 @@
 
 #endif
+
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/Container.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/Container.h	(revision 1014)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/Container.h	(revision 1014)
@@ -0,0 +1,65 @@
+#ifndef __CONTAINER_H__
+#define __CONTAINER_H__
+
+template <class T>
+class ObjList
+{
+public:
+	ObjList(void){ clear(); }
+
+	~ObjList(void){
+		if (data)
+			free(data);
+		data_size=0;
+		capacity=0;
+	}
+
+	ObjList(const ObjList &l){
+		this->operator =(l);	
+	}
+
+	void push_back(T i){
+		if (data_size>=capacity)
+		{
+			capacity *= 2;
+			data = (T*)realloc(data,capacity*sizeof(T));
+		}
+		data[data_size] = i;
+		data_size++;
+	}
+
+	T & operator[](unsigned int i){ assert(i<data_size); return data[i]; }
+	const T & operator[](unsigned int i) const { assert(i<data_size); return data[i]; }
+
+	const ObjList & operator=(const ObjList &l){
+/*		capacity=l.capacity;
+		data_size=l.data_size;
+		data=(T*)malloc(capacity*sizeof(T));
+		memcpy(data,l.data,data_size*sizeof(T));*/
+		clear();
+		for (unsigned int i=0; i<l.size(); i++)
+			push_back(l[i]);
+		return l;
+	}
+
+	unsigned int size(void) const { return data_size; }
+
+	void clear(void){
+		capacity=16;
+		data=(T*)malloc(capacity*sizeof(T));
+		data_size=0;
+	}
+
+	void eraseAtPos(unsigned int i){
+		if (i!=data_size-1)
+			memmove(data+i,data+i+1,(data_size-i-1)*sizeof(T));
+		data_size--;
+	}
+
+private:
+	T *data;
+	unsigned int data_size;
+	unsigned int capacity;
+};
+
+#endif