Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 1020)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 1023)
@@ -79,5 +79,5 @@
 	Environment::GetSingleton()->GetFloatValue("VspBspTree.Termination.maxRayContribution", mTermMaxRayContribution);
 	Environment::GetSingleton()->GetFloatValue("VspBspTree.Termination.minAccRayLenght", mTermMinAccRayLength);
-	Environment::GetSingleton()->GetFloatValue("VspBspTree.Termination.maxCostRatio", mTermMaxCostRatio);
+	
 	Environment::GetSingleton()->GetIntValue("VspBspTree.Termination.missTolerance", mTermMissTolerance);
 	Environment::GetSingleton()->GetIntValue("VspBspTree.Termination.maxViewCells", mMaxViewCells);
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 1020)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 1023)
@@ -1541,5 +1541,5 @@
 	RegisterOption("BspTree.Construction.epsilon",
 		optFloat,
-		"bsp_construction_side_tolerance=",
+		"bsp_construction_epsilon=",
 		"0.002");
 
@@ -1859,5 +1859,5 @@
 
 /************************************************************************************/
-/*               View space partition BSP tree related options                      */
+/*                      Rss preprocessor related options                            */
 /************************************************************************************/
 
@@ -1875,5 +1875,5 @@
 
 /************************************************************************************/
-/*               View space partition BSP tree related options                      */
+/*                 View space partition BSP tree related options                    */
 /************************************************************************************/
 
@@ -2004,5 +2004,5 @@
 	RegisterOption("VspBspTree.Construction.epsilon",
 					optFloat,
-					"vsp_bsp_construction_side_tolerance=",
+					"vsp_bsp_construction_epsilon=",
 					"0.002");
 
@@ -2087,6 +2087,118 @@
 		"8.0");
 
+
+
+/************************************************************************************/
+/*                 View space partition tree related options                        */
+/************************************************************************************/
+
 	
+	RegisterOption("VspTree.Termination.maxDepth",
+					optInt,
+					"vsp_term_max_depth=",
+					"100");
+
+	RegisterOption("VspTree.Termination.minRays",
+					optInt,
+					"vsp_term_min_rays=",
+					"-1");
+
+
+	RegisterOption("VspTree.Termination.minPvs",
+					optInt,
+					"vsp_term_min_pvs=",
+					"20");
+
+	RegisterOption("VspTree.Termination.minProbability",
+					optFloat,
+					"vsp_term_min_probability=",
+					"0.001");
+
 	
+	RegisterOption("VspTree.Termination.maxRayContribution",
+			optFloat,
+			"vsp_term_ray_contribution=",
+			"0.9");
+	
+	RegisterOption("VspTree.Termination.maxCostRatio",
+		optFloat,
+		"vsp_term_max_cost_ratio=",
+		"1.5");
+	
+	RegisterOption("VspTree.Termination.maxViewCells",
+		optInt,
+		"vsp_term_max_view_cells=",
+		"10000");
+
+	
+	RegisterOption("VspTree.Termination.missTolerance",
+		optInt,
+		"vsp_term_miss_tolerance=",
+		"4");
+
+	RegisterOption("VspTree.Termination.minGlobalCostRatio",
+					optFloat,
+					"vsp_term_min_global_cost_ratio=",
+					"0.0001");
+
+	RegisterOption("VspTree.useSplitCostQueue",
+		optBool,
+		"vsp_use_split_cost_queue=",
+		"true");
+
+	RegisterOption("VspTree.Termination.globalCostMissTolerance",
+					optInt,
+					"vsp_term_global_cost_miss_tolerance=",
+					"4");
+
+ 	RegisterOption("VspTree.Termination.ct_div_ci",
+					optFloat,
+					"vsp_term_ct_div_ci=",
+					"0.0");
+
+	RegisterOption("VspTree.Construction.epsilon",
+					optFloat,
+					"vsp_construction_epsilon=",
+					"0.002");
+
+	RegisterOption("VspTree.splitUseOnlyDrivingAxis", 
+					optBool, 
+					"vsp_split_only_driving_axis=", 
+					"false");
+
+	RegisterOption("VspTree.maxStaticMemory", 
+		optFloat, 
+		"vsp_max_static_mem=", 
+		"8.0");
+
+	RegisterOption("VspTree.useCostHeuristics",
+		optBool,
+		"vsp_use_cost_heuristics=",
+		"false");
+
+	RegisterOption("VspTree.simulateOctree", 
+		optBool, 
+		"vsp_simulate_octree=", 
+		"false");
+
+	RegisterOption("VspTree.Construction.randomize", 
+		optBool, 
+		"vsp_construction_randomize=", 
+		"false");
+
+	RegisterOption("VspTree.subdivisionStats",
+					optString,
+					"vsp_subdivision_stats=",
+					"vspSubdivisionStats.log");
+
+	RegisterOption("VspTree.Construction.minBand",
+					optFloat,
+					"vsp_construction_min_band=",
+					"0.1");
+
+	RegisterOption("VspTree.Construction.maxBand",
+					optFloat,
+					"vsp_construction_min_band=",
+					"0.9");
 
 	//////////////////////////////////////////////////////////////////////////////////
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1022)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1023)
@@ -333,5 +333,4 @@
 mOutOfBoundsCell(NULL),
 mStoreRays(false),
-mUseRandomAxis(false),
 mTimeStamp(1)
 {
@@ -347,5 +346,5 @@
 	Environment::GetSingleton()->GetFloatValue("VspTree.Termination.minProbability", mTermMinProbability);
 	Environment::GetSingleton()->GetFloatValue("VspTree.Termination.maxRayContribution", mTermMaxRayContribution);
-	Environment::GetSingleton()->GetFloatValue("VspTree.Termination.maxCostRatio", mTermMaxCostRatio);
+	
 	Environment::GetSingleton()->GetIntValue("VspTree.Termination.missTolerance", mTermMissTolerance);
 	Environment::GetSingleton()->GetIntValue("VspTree.Termination.maxViewCells", mMaxViewCells);
@@ -373,7 +372,6 @@
 	Environment::GetSingleton()->GetBoolValue("VspTree.useCostHeuristics", mUseCostHeuristics);
 	Environment::GetSingleton()->GetBoolValue("VspTree.simulateOctree", mCirculatingAxis);
-	Environment::GetSingleton()->GetBoolValue("VspTree.useRandomAxis", mUseRandomAxis);
-	Environment::GetSingleton()->GetIntValue("VspTree.nodePriorityQueueType", mNodePriorityQueueType);
-	
+	
+
 	char subdivisionStatsLog[100];
 	Environment::GetSingleton()->GetStringValue("VspTree.subdivisionStats", subdivisionStatsLog);
@@ -403,6 +401,5 @@
 	Debug << "use cost heuristics: " << mUseCostHeuristics << endl;
 	Debug << "subdivision stats log: " << subdivisionStatsLog << endl;
-	Debug << "use random axis: " << mUseRandomAxis << endl;
-	Debug << "priority queue type: " << mNodePriorityQueueType << endl;
+	
 	Debug << "circulating axis: " << mCirculatingAxis << endl;
 	Debug << "minband: " << mMinBand << endl;
@@ -1025,9 +1022,7 @@
 	// if we use some kind of specialised fixed axis
     const bool useSpecialAxis = 
-		mOnlyDrivingAxis || mUseRandomAxis || mCirculatingAxis;
-
-	if (mUseRandomAxis)
-		sAxis = Random(3);
-	else if (mCirculatingAxis)
+		mOnlyDrivingAxis || mCirculatingAxis;
+
+	if (mCirculatingAxis)
 		sAxis = (tData.mAxis + 1) % 3;
 	else if (mOnlyDrivingAxis)
@@ -2331,5 +2326,5 @@
 	Environment::GetSingleton()->GetFloatValue("VspTree.Termination.minProbability", mTermMinProbability);
 	Environment::GetSingleton()->GetFloatValue("VspTree.Termination.maxRayContribution", mTermMaxRayContribution);
-	Environment::GetSingleton()->GetFloatValue("VspTree.Termination.maxCostRatio", mTermMaxCostRatio);
+	
 	Environment::GetSingleton()->GetIntValue("VspTree.Termination.missTolerance", mTermMissTolerance);
 	Environment::GetSingleton()->GetIntValue("VspTree.Termination.maxViewCells", mMaxViewCells);
@@ -2357,7 +2352,6 @@
 	Environment::GetSingleton()->GetBoolValue("VspTree.useCostHeuristics", mUseCostHeuristics);
 	Environment::GetSingleton()->GetBoolValue("VspTree.simulateOctree", mCirculatingAxis);
-	Environment::GetSingleton()->GetBoolValue("VspTree.useRandomAxis", mUseRandomAxis);
-	Environment::GetSingleton()->GetIntValue("VspTree.nodePriorityQueueType", mNodePriorityQueueType);
-	
+
+
 	char subdivisionStatsLog[100];
 	Environment::GetSingleton()->GetStringValue("VspTree.subdivisionStats", subdivisionStatsLog);
@@ -2387,6 +2381,5 @@
 	Debug << "use cost heuristics: " << mUseCostHeuristics << endl;
 	Debug << "subdivision stats log: " << subdivisionStatsLog << endl;
-	Debug << "use random axis: " << mUseRandomAxis << endl;
-	Debug << "priority queue type: " << mNodePriorityQueueType << endl;
+	
 	Debug << "circulating axis: " << mCirculatingAxis << endl;
 	Debug << "minband: " << mMinBand << endl;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.h	(revision 1021)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.h	(revision 1023)
@@ -1049,10 +1049,4 @@
 	float mEpsilon;
 
-	/// if we should use breath first priority for the splits
-	int mNodePriorityQueueType;
-
-	// priority queue strategy
-	enum {BREATH_FIRST, DEPTH_FIRST, COST_BASED};
-
 
 	/// subdivision stats output file
@@ -1581,7 +1575,4 @@
 	float mEpsilon;
 
-	/// if we should use breath first priority for the splits
-	int mNodePriorityQueueType;
-
 
 	/// subdivision stats output file