Index: GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/Plugins.cfg
===================================================================
--- GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/Plugins.cfg	(revision 1030)
+++ GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/Plugins.cfg	(revision 1030)
@@ -0,0 +1,15 @@
+# Defines plugins to load
+
+# Define plugin folder
+PluginFolder=.
+
+# Define plugins
+Plugin=RenderSystem_Direct3D7
+Plugin=RenderSystem_Direct3D9
+Plugin=RenderSystem_GL
+Plugin=Plugin_ParticleFX
+Plugin=Plugin_BSPSceneManager
+Plugin=Plugin_OctreeSceneManager
+Plugin=Plugin_CgProgramManager
+
+
Index: GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/ogre.cfg
===================================================================
--- GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/ogre.cfg	(revision 1030)
+++ GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/ogre.cfg	(revision 1030)
@@ -0,0 +1,7 @@
+Render System	Direct3D9 Rendering SubSystem
+Anti aliasing	None
+Floating-point mode	Fastest
+Full Screen	Yes
+Rendering Device	NVIDIA GeForce 6800 Series GPU
+VSync	No
+Video Mode	800 x 600 @ 32-bit colour
Index: GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/terrain.cfg
===================================================================
--- GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/terrain.cfg	(revision 1030)
+++ GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/terrain.cfg	(revision 1030)
@@ -0,0 +1,73 @@
+# The main world texture (if you wish the terrain manager to create a material for you)
+WorldTexture=terrain_texture.jpg
+
+# The detail texture (if you wish the terrain manager to create a material for you)
+DetailTexture=terrain_detail.jpg
+
+#number of times the detail texture will tile in a terrain tile
+DetailTile=3
+
+# Heightmap source
+PageSource=Heightmap
+
+# Heightmap-source specific settings
+Heightmap.image=terrain.png
+
+# If you use RAW, fill in the below too
+# RAW-specific setting - size (horizontal/vertical)
+#Heightmap.raw.size=513
+# RAW-specific setting - bytes per pixel (1 = 8bit, 2=16bit)
+#Heightmap.raw.bpp=2
+# Use this if you want to flip the terrain (eg Terragen exports raw upside down)
+#Heightmap.flip=true
+
+# How large is a page of tiles (in vertices)? Must be (2^n)+1
+PageSize=513
+
+# How large is each tile? Must be (2^n)+1 and be smaller than PageSize
+TileSize=65
+
+# The maximum error allowed when determining which LOD to use
+MaxPixelError=3
+
+# The size of a terrain page, in world units
+PageWorldX=1500
+PageWorldZ=1500
+# Maximum height of the terrain 
+MaxHeight=100
+
+# Upper LOD limit
+MaxMipMapLevel=5
+
+VertexNormals=yes
+#VertexColors=yes
+#UseTriStrips=yes
+
+# Use vertex program to morph LODs, if available
+VertexProgramMorph=yes
+
+# The proportional distance range at which the LOD morph starts to take effect
+# This is as a proportion of the distance between the current LODs effective range,
+# and the effective range of the next lower LOD
+LODMorphStart=0.2
+
+# This following section is for if you want to provide your own terrain shading routine
+# Note that since you define your textures within the material this makes the 
+# WorldTexture and DetailTexture settings redundant
+
+# The name of the vertex program parameter you wish to bind the morph LOD factor to
+# this is 0 when there is no adjustment (highest) to 1 when the morph takes it completely
+# to the same position as the next lower LOD
+# USE THIS IF YOU USE HIGH-LEVEL VERTEX PROGRAMS WITH LOD MORPHING
+#MorphLODFactorParamName=morphFactor
+
+# The index of the vertex program parameter you wish to bind the morph LOD factor to
+# this is 0 when there is no adjustment (highest) to 1 when the morph takes it completely
+# to the same position as the next lower LOD
+# USE THIS IF YOU USE ASSEMBLER VERTEX PROGRAMS WITH LOD MORPHING
+#MorphLODFactorParamIndex=4
+
+# The name of the material you will define to shade the terrain
+CustomMaterialName=TestTerrainMaterial
+
+
Index: GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/resources.cfg
===================================================================
--- GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/resources.cfg	(revision 1030)
+++ GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/resources.cfg	(revision 1030)
@@ -0,0 +1,22 @@
+# Resource locations to be added to the 'boostrap' path
+# This also contains the minimum you need to use the Ogre example framework
+[Bootstrap]
+Zip=../../../OgreStuff/media/packs/OgreCore.zip
+
+# Resource locations to be added to the default path
+[General]
+FileSystem=../../../OgreStuff/media
+FileSystem=../../../OgreStuff/media/fonts
+FileSystem=../../../OgreStuff/media/materials/programs
+FileSystem=../../../OgreStuff/media/materials/scripts
+FileSystem=../../../OgreStuff/media/materials/textures
+FileSystem=../../../OgreStuff/media/models
+FileSystem=../../../OgreStuff/media/overlays
+FileSystem=../../../OgreStuff/media/particle
+FileSystem=../../../OgreStuff/media/gui
+FileSystem=../../../OgreStuff/media/GT
+Zip=../../../OgreStuff/media/packs/cubemap.zip
+Zip=../../../OgreStuff/media/packs/cubemapsJS.zip
+Zip=../../../OgreStuff/media/packs/fresneldemo.zip
+Zip=../../../OgreStuff/media/packs/ogretestmap.zip
+Zip=../../../OgreStuff/media/packs/skybox.zip
Index: GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/media.cfg
===================================================================
--- GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/media.cfg	(revision 1030)
+++ GTP/trunk/App/Demos/Geom/OgreStuff/bin/release/media.cfg	(revision 1030)
@@ -0,0 +1,16 @@
+Mesh=ogrehead.mesh
+Mesh=geosphere4500.mesh
+Mesh=razor.mesh
+Mesh=knot.mesh
+Mesh=RZR-002.mesh
+Mesh=geosphere8000.mesh
+Mesh=sphere.mesh
+
+CubeMap=cubescene.jpg
+CubeMap=early_morning.jpg
+CubeMap=cubemap.jpg
+CubeMap=morning.jpg
+CubeMap=cloudy_noon.jpg
+CubeMap=evening.jpg
+CubeMap=stormy.jpg
+CubeMap=stevecube.jpg
Index: GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/Plugins.cfg
===================================================================
--- GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/Plugins.cfg	(revision 1030)
+++ GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/Plugins.cfg	(revision 1030)
@@ -0,0 +1,15 @@
+# Defines plugins to load
+
+# Define plugin folder
+PluginFolder=.
+
+# Define plugins
+Plugin=RenderSystem_Direct3D7
+Plugin=RenderSystem_Direct3D9
+Plugin=RenderSystem_GL
+Plugin=Plugin_ParticleFX
+Plugin=Plugin_BSPSceneManager
+Plugin=Plugin_OctreeSceneManager
+Plugin=Plugin_CgProgramManager
+
+
Index: GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/ogre.cfg
===================================================================
--- GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/ogre.cfg	(revision 1030)
+++ GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/ogre.cfg	(revision 1030)
@@ -0,0 +1,7 @@
+Render System	OpenGL Rendering Subsystem
+Colour Depth	32
+Display Frequency	N/A
+FSAA	0
+Full Screen	No
+VSync	No
+Video Mode	1024 x 768
Index: GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/terrain.cfg
===================================================================
--- GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/terrain.cfg	(revision 1030)
+++ GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/terrain.cfg	(revision 1030)
@@ -0,0 +1,71 @@
+# The main world texture (if you wish the terrain manager to create a material for you)
+WorldTexture=terrain_texture.jpg
+
+# The detail texture (if you wish the terrain manager to create a material for you)
+DetailTexture=terrain_detail.jpg
+
+#number of times the detail texture will tile in a terrain tile
+DetailTile=3
+
+# Heightmap source
+PageSource=Heightmap
+
+# Heightmap-source specific settings
+Heightmap.image=terrain.png
+
+# If you use RAW, fill in the below too
+# RAW-specific setting - size (horizontal/vertical)
+#Heightmap.raw.size=513
+# RAW-specific setting - bytes per pixel (1 = 8bit, 2=16bit)
+#Heightmap.raw.bpp=2
+# Use this if you want to flip the terrain (eg Terragen exports raw upside down)
+#Heightmap.flip=true
+
+# How large is a page of tiles (in vertices)? Must be (2^n)+1
+PageSize=513
+
+# How large is each tile? Must be (2^n)+1 and be smaller than PageSize
+TileSize=65
+
+# The maximum error allowed when determining which LOD to use
+MaxPixelError=3
+
+# The size of a terrain page, in world units
+PageWorldX=1500
+PageWorldZ=1500
+# Maximum height of the terrain 
+MaxHeight=100
+
+# Upper LOD limit
+MaxMipMapLevel=5
+
+VertexNormals=yes
+#VertexColors=yes
+#UseTriStrips=yes
+
+# Use vertex program to morph LODs, if available
+VertexProgramMorph=yes
+
+# The proportional distance range at which the LOD morph starts to take effect
+# This is as a proportion of the distance between the current LODs effective range,
+# and the effective range of the next lower LOD
+LODMorphStart=0.2
+
+# This following section is for if you want to provide your own terrain shading routine
+# Note that since you define your textures within the material this makes the 
+# WorldTexture and DetailTexture settings redundant
+
+# The name of the vertex program parameter you wish to bind the morph LOD factor to
+# this is 0 when there is no adjustment (highest) to 1 when the morph takes it completely
+# to the same position as the next lower LOD
+# USE THIS IF YOU USE HIGH-LEVEL VERTEX PROGRAMS WITH LOD MORPHING
+#MorphLODFactorParamName=morphFactor
+
+# The index of the vertex program parameter you wish to bind the morph LOD factor to
+# this is 0 when there is no adjustment (highest) to 1 when the morph takes it completely
+# to the same position as the next lower LOD
+# USE THIS IF YOU USE ASSEMBLER VERTEX PROGRAMS WITH LOD MORPHING
+#MorphLODFactorParamIndex=4
+
+# The name of the material you will define to shade the terrain
+CustomMaterialName=TestTerrainMaterial
Index: GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/quake3settings.cfg
===================================================================
--- GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/quake3settings.cfg	(revision 1030)
+++ GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/quake3settings.cfg	(revision 1030)
@@ -0,0 +1,2 @@
+Pak0Location: f:\quake3arena\baseq3\pak0.pk3
+Map: maps/q3dm3.bsp
Index: GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/resources.cfg
===================================================================
--- GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/resources.cfg	(revision 1030)
+++ GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/resources.cfg	(revision 1030)
@@ -0,0 +1,22 @@
+# Resource locations to be added to the 'boostrap' path
+# This also contains the minimum you need to use the Ogre example framework
+[Bootstrap]
+Zip=../../../OgreStuff/media/packs/OgreCore.zip
+
+# Resource locations to be added to the default path
+[General]
+FileSystem=../../../OgreStuff/media
+FileSystem=../../../OgreStuff/media/fonts
+FileSystem=../../../OgreStuff/media/materials/programs
+FileSystem=../../../OgreStuff/media/materials/scripts
+FileSystem=../../../OgreStuff/media/materials/textures
+FileSystem=../../../OgreStuff/media/models
+FileSystem=../../../OgreStuff/media/overlays
+FileSystem=../../../OgreStuff/media/particle
+FileSystem=../../../OgreStuff/media/gui
+FileSystem=../../../OgreStuff/media/GT
+Zip=../../../OgreStuff/media/packs/cubemap.zip
+Zip=../../../OgreStuff/media/packs/cubemapsJS.zip
+Zip=../../../OgreStuff/media/packs/fresneldemo.zip
+Zip=../../../OgreStuff/media/packs/ogretestmap.zip
+Zip=../../../OgreStuff/media/packs/skybox.zip
Index: GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/media.cfg
===================================================================
--- GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/media.cfg	(revision 1030)
+++ GTP/trunk/App/Demos/Geom/OgreStuff/bin/debug/media.cfg	(revision 1030)
@@ -0,0 +1,16 @@
+Mesh=ogrehead.mesh
+Mesh=geosphere4500.mesh
+Mesh=razor.mesh
+Mesh=knot.mesh
+Mesh=RZR-002.mesh
+Mesh=geosphere8000.mesh
+Mesh=sphere.mesh
+
+CubeMap=cubescene.jpg
+CubeMap=early_morning.jpg
+CubeMap=cubemap.jpg
+CubeMap=morning.jpg
+CubeMap=cloudy_noon.jpg
+CubeMap=evening.jpg
+CubeMap=stormy.jpg
+CubeMap=stevecube.jpg